import numpy as np


def get_multiple(func):
    """
    Get multiple outputs; a decorator function.

    This function looks for * wildcards and applies the function func(*args)
    on all sub functions.
    """

    def inner(self, par, *arg, **kwarg):
        if '*' in par:
            idx_star = par.find('*')

            # find number of subcomponents
            idx_point = par[:idx_star].rfind('.')
            n_subcomponents = self._get_int(par[:idx_point]
                                            + '.Subcomponents', *arg, **kwarg)

            # iterate over all objects
            ret = []
            for i in range(n_subcomponents):
                char_name = par[:idx_point+1]+'Subcomponents'+':'+str(i+1)
                char_name = self._get_char(char_name)
                char_name = par[:idx_point+1]+char_name+par[(idx_star+1):]
                res = get_multiple(func)(self, char_name)

                print('--')
                print('res: ', res)
                if hasattr(res, '__len__') and len(res) > 0:
                    if len(ret) == 0:
                        ret = np.array([res]).reshape(-1, 1)
                    else:
                        ret = np.append(ret, res.reshape(-1, 1), axis=1)
                elif ~ hasattr(res, '__len__'):
                    ret = np.append(ret, res, axis=0)
            print('ret:  ', ret)
            return ret
        return func(self, par, *arg, **kwarg)
    return inner
