import circadapt
from circadapt.components import General
from circadapt.components.solver import Solver


class Model(circadapt.CircAdapt):
    def __init__(self, solver):
        circadapt.CircAdapt.__init__(
            self,
            'Custom',
            solver,
            )
        self._components['Solver'] = Solver(self)
        self._components['General'] = General(self)

        # rerun get_model_reference for first-time use
        # If P_ref_model is not there, it will be created here
        _ = self.get_model_reference()

from circadapt.model.vanosta2023 import VanOsta2023
